#!/usr/bin/env perl
 
#use warnings;
use strict;
use Getopt::Std;
use Switch;
 
my %options;
my ($t, $dial, $text_raw);
 
getopts("H:m:s:p:", \%options);
 
if (not $options{H} or not $options{m} or not $options{s} or not $options{p} )
{
    print "\nUsage: $0 -H 'host_name' -s 'service_name' -p 'phone number' -m 'tts message'\n\n";
    exit;
}
 
# Depending on the kind of alert.. you may want to customize the message a litle.
switch ($options{s})
{
    case /international_forwarding_alert/i		{ $text_raw = "Possible fraud on, $options{H} $options{m}"; }
 
    else			{ $text_raw = "No match. Something is wrong on host $options{H}. The message is, $options{m}"; }
 
}
 
my $text = speechify($text_raw);
 
# Can't pass commas through asterisk parameter list
$text =~ s/,/+/g;
 
#print "$text\n";
#exit;
 
# Generate the call file
$dial  = "Channel: SIP/SJC/$options{p}\n";
$dial .= "Callerid: Nagios <7045551212>\n"; # Originating number..
$dial .= "MaxRetries: 5\n";
$dial .= "RetryTime: 60\n";
$dial .= "WaitTime: 60\n";
$dial .= "Context: nagios-out\n";
$dial .= "Extension: s\n";
$dial .= "Priority: 1\n";
$dial .= "Set: Params=$options{H}|$options{s}|$text\n";
 
open my $FP, '>', "/var/spool/asterisk/tmp/dial.call" or die ("Unable to write temp call file");
 
print $FP $dial;
close $FP;
 
$t = hown asterisk.asterisk /var/spool/asterisk/tmp/dial.call;
$t = 
v /var/spool/asterisk/tmp/dial.call /var/spool/asterisk/outgoing/;
 
sub speechify
{
    my ($r) = @_;
 
    # Transform a into b to sound right when using TTS
    my %s = (
          'as1.iad01' => 'a s 1 dot i a d 0 1, ',
          'as2.iad01' => 'a s 2 dot i a d 0 1, ',
          'as1.sjc01' => 'a s 1 dot s j c 0 1, ',
          'as2.sjc01' => 'a s 2 dot s j c 0 1, ',
          'as1.ams01' => 'a s 1 dot a m s 0 1, ',
          'as2.ams02' => 'a s 2 dot a m s 0 1, ',
          'as1.smb01' => 'a s 1 dot s m b 0 1, ',
          'as2.smb01' => 'a s 2 dot s m b 0 1, ',
          'groupid'   => 'group i d, ',
          'userid'    => 'user i d, ',
          'calledby'  => 'called by, ',
         );
 
    my @split = split / /, $r;
    my @out = ();
    my $lastbite;
 
    BITE: foreach my $bite (@split)
    {
 
        # Check the hash for a known word replacement
        foreach my $key ( keys %s )
        {
            if ($bite =~ /$key/i)
            {
                $lastbite = $bite;
                $bite =~ s/$bite/$s{$key}/i;
                push @out, $bite;
                next BITE;
            }
        }
 
        # The thing/word folling any of these needs to be spelled out
        if ($lastbite =~ /groupid/i or $lastbite =~ /userid/i)
        {
            $lastbite = $bite;
            $bite =~ s/(\w)(?=\w)/$1 /g;
            push @out, "$bite, ";
            next BITE;
        }
 
        push @out, $bite;
        $lastbite = $bite;
    }
 
    return "@out";
}
